#include<stdio.h>
#include<stdlib.h>
#include<kikakubu.h>
#include<kanade.h>
#include<kyotsu.h>

#define A 0x80
#define B 0x40
#define SELECT 0x20
#define START 0x10
#define UP 0x08
#define DOWN 0x04
#define LEFT 0x02
#define RIGHT 0x01

#define TITLE 0
#define OPTION 1
#define GAME 2
#define GAMEOVER 3

#define APU_CH1_REG0 (*(unsigned char*)0x4000)
#define APU_CH1_REG1 (*(unsigned char*)0x4001)
#define APU_CH1_REG2 (*(unsigned char*)0x4002)
#define APU_CH1_REG3 (*(unsigned char*)0x4003)
#define APU_PLAY_CH  (*(unsigned char*)0x4015)
#define APU_CH2_REG0 (*(unsigned char*)0x4004)
#define APU_CH2_REG1 (*(unsigned char*)0x4005)
#define APU_CH2_REG2 (*(unsigned char*)0x4006)
#define APU_CH2_REG3 (*(unsigned char*)0x4007)
#define APU_NOISE_REG0 (*(unsigned char*)0x400C)
#define APU_NOISE_REG1 (*(unsigned char*)0x400E)
#define APU_NOISE_REG2 (*(unsigned char*)0x400F)
#define APU_PLAY_CH  (*(unsigned char*)0x4015)
#define APU_REG0_DUTY_875  0x00
#define APU_REG0_DUTY_750  0x40
#define APU_REG0_DUTY_500  0x80
#define APU_REG0_DUTY_250  0xC0
#define APU_REG0_COUNT_OFF 0x00
#define APU_REG0_COUNT_ON  0x20
#define APU_REG0_FIX_OFF   0x00
#define APU_REG0_FIX_ON    0x10
#define APU_REG1_FRQCHG_ON  0x80
#define APU_REG1_FRQCHG_OFF 0x00
#define APU_REG1_FRQCHG_DSC 0x08
#define APU_REG1_FRQCHG_ASC 0x00

#define DO 0
#define DOS 1
#define RE 2
#define RES 3
#define MI 4
#define FA 5
#define FAS 6
#define SO 7
#define SOS 8
#define RA 9
#define RAS 10
#define SI 11
#define DO2 12
#define DOS2 13
#define RE2 14
#define RES2 15
#define MI2 16
#define FA2 17
#define FAS2 18
#define SO2 19
#define SOS2 20
#define RA2 21
#define RAS2 22
#define SI2 23
#define DO3 24
#define ST 25
#define END 26
#define REST 27


// XN[̃IEIt
void ShowScreen(char ShowFlag)
{
	if (ShowFlag == 1) {
		*(char*)0x2000 = 0x08;
		*(char*)0x2001 = 0x1e;
	} else {
		*(char*)0x2000 = 0x00;
		*(char*)0x2001 = 0x00;
	}
}

unsigned char Pad;

void SetDraw(char x,char y,char number)
{
	int adr;
	adr = (y-1)*32+x;
	*(char*)0x2006 = 0x20+adr/256; 
	*(char*)0x2006 = adr;
	
	*(char*)0x2007 = number;
}

void SetDraw2(char addHigh,char addLow,char number)
{
	*(char*)0x2006=addHigh;
	*(char*)0x2006=addLow;
	
	*(char*)0x2007=number;
}
void BGwrite(char x,char y,char str[])
{
	
	char i=0;
	int adr=(y-1)*32+x;
	*(char*)0x2006=0x20+adr/256;
	*(char*)0x2006=adr;
	while(str[i])
	{
		*(char*)0x2006=0x20+adr/256;
		*(char*)0x2006=adr+i;
		*(char*)0x2007=str[i];
		i++;
	}
}
void KeyInput()
{
	unsigned char t;
	char i;
	
	*(char*)0x4016 = 1;
	*(char*)0x4016 = 0;
	
	for (i = 0; i < 8; i++) {
		t = *(char *)0x4016;
		t &= 0x01;
		Pad <<= 1;
		Pad += t;
	}
}

void DrawSprite(char x,char y,char bitflag,char number,char first)
{
	if(first)
	{	
		*(char*)0x2003=0;
	}
	*(char*)0x2004=y;
	*(char*)0x2004=number;
	*(char*)0x2004=bitflag;
	*(char*)0x2004=x;
}





void SoundPlay(unsigned char note, unsigned char vol)
{
    unsigned char scale_hi3[]={  1,   1,   1,  1,    1,   1,   1,  1,  1,     0,   0,   0,
                                 0,   0,   0,   0,   0,   0,   0,  0,  0,     0,   0,   0,
                                 0};
    							 
    unsigned char scale_lo3[]={171, 149 ,125, 104, 83,  64,   46, 29,  14,  254, 240, 188,
                               214, 201, 190, 179, 170, 160, 151, 143, 134, 127, 120, 113,
                               107};
    vol &= 0x0F;
    if(note==REST) {APU_PLAY_CH=0x00;return;}
    APU_PLAY_CH = 0x0B;
    APU_CH1_REG0 = APU_REG0_DUTY_875 | APU_REG0_COUNT_ON | APU_REG0_FIX_ON | vol;
    APU_CH1_REG1 = APU_REG1_FRQCHG_ON;
    
    APU_CH1_REG2 = scale_lo3[note];
    APU_CH1_REG3 = 0xF8 | scale_hi3[note];
    
}

void SoundPlay2(unsigned char note, unsigned char vol)
{
    unsigned char scale_hi3[]={  1,   1,   1,  1,    1,   1,   1,  1,  1,     0,   0,   0,
                                 0,   0,   0,   0,   0,   0,   0,  0,  0,     0,   0,   0,
                                 0};
    							 
    unsigned char scale_lo3[]={171, 149 ,125, 104, 83,  64,   46, 29,  14,  254, 240, 188,
                               214, 201, 190, 179, 170, 160, 151, 143, 134, 127, 120, 113,
                               107};
    vol &= 0x0F;
    APU_PLAY_CH = 0x0B;
    APU_CH2_REG0 = APU_REG0_DUTY_500 | APU_REG0_COUNT_ON | APU_REG0_FIX_ON | vol;
    APU_CH2_REG1 = APU_REG1_FRQCHG_OFF;
    
    if(note==END)
    {
    	APU_PLAY_CH=0x09;
    	return;
    }
    if(note==ST)
    {
    	APU_PLAY_CH=0x0B;
    	return;
    }
    
    APU_CH2_REG2 = scale_lo3[note];
    APU_CH2_REG3 = 0xF8 | scale_hi3[note];
    
}

void PlayNoise2()
{
	
	
	{
	APU_PLAY_CH = 0x0B;
	//mCYWX^
    APU_NOISE_REG0 = 0xEF;
    //mCYWX^
    APU_NOISE_REG1 = 0x04;
    
    //mCYWX^
    APU_NOISE_REG2 = 0xFB;
    }
}
char *sin;
char *cos;


void MoveCircle()
{
	static int angle=0;
	static unsigned char x[12]={0};
	static unsigned char y[12]={0};
	signed char addx=0;
	signed char addy=0;
	int i=0;
	static int flag=1;
	static int index=0;
	char *hankei;
	static char r=30;
	char angle2=0;
	char s1,s2,s3;
	//static 
	sin=0xC000;
	cos=0xC168;
	if(flag==1)
		r=30;
	hankei=&r;
	
	//VBlank();
	for(i=0;i<12;i++)
	{
		addx=(signed char)*(cos+angle+(i*30)) ;//*30)/100;
		addy=(signed char)*(sin+angle+(i*30)) ;//*30)/100;
		x[i]=128+(addx*(signed char)(*hankei))/(signed char)100;
		y[i]=120-(addy*(signed char)(*hankei))/(signed char)100;
		
		DrawSprite(x[i],y[i],index,1,flag);
		index=(index+1)%4;
		flag=0;
	}
	
	s1=(r/100)%10;
	s2=(r/10)%10;
	s3=(r/1)%10;
	DrawSprite(18*8,20*8,0,s1+0x30,0);
	DrawSprite(19*8,20*8,0,s2+0x30,0);
	DrawSprite(20*8,20*8,0,s3+0x30,0);
	if(Pad & A) {
		r++;
		if(r>120)
			r=120;
	}
	if(Pad & B) {
		r--;
		if(r<5) 
		r=5;
	}
	
	angle=(angle+1)%360;

	
}



void NMIProc(void)
{
	
}


// C֐
char NesMain()
{
	char r;
	
	const char palettes[] = {
		0x0f, 0x11, 0x21, 0x30,
		0x0f, 0x11, 0x21, 0x30,
		0x0f, 0x11, 0x21, 0x30,
		0x0f, 0x11, 0x21, 0x30,
		0x0f, 0x17, 0x37, 0x27,
		0x0f, 0x07, 0x19, 0x39,
		0x0f, 0x07, 0x15, 0x00,
		0x0f, 0x00, 0x10, 0x30
	};
	char y=0;
	char i;
	char prev=0,prev2=0;
	char cnt=0,index=0;
	int cnt2=0;
	char add=0;
	
	
	ShowScreen(0);
	
	
	
	// pbg
	*(char*)0x2006 = 0x3f;
	*(char*)0x2006 = 0x00;
	for (i = 0; i < 0x20; i ++)
		*(char*)0x2007 = palettes[i];
	
	// l[e[u֏
	
	
	BGwrite(8,10,"SIN COS SAMPLE");
	BGwrite(0,12,"PUSH A TO RADIUS IS UP!!");
	BGwrite(0,13,"PUSH B TO RADIUS IS DOWN!!");
	BGwrite(15,20,"RADIUS IS");
	SetScroll(0, 0);
	ShowScreen(1);

	while(1){
	// C[v
		MoveCircle();
		SetScroll(0,0);
		KeyInput();
	}

	
	return 0;
}

